/* $Id: aud_db.h 333 2007-06-18 13:57:46Z pkun $ */

#ifndef _PARSEC_WCAUD_DB_H_
#define _PARSEC_WCAUD_DB_H_

#include <parsec/aud_db.h>
#include <wchar.h>

#ifdef __cplusplus
extern "C" {
#endif
	struct wcaudit_entry {
		int type;	/* The entry type: AUDIT_ENTRY_USER, .._GROUP, or .._OTHER. */
		wchar_t *name;	/* User's or group's name. For "other" entry this field is empty. */
		audit_ps_t succ;	/* Audit these events in case of success. */
		audit_ps_t fail;	/* Audit these events in case of failure. */
	};

	extern aud_han_t wcopenauddb(void);
	extern int wccloseauddb(aud_han_t han);
	extern int wcsetaudent(aud_han_t han, int for_types);

	extern int wcendaudent(aud_han_t han);

	extern int wcfreeaudent(struct wcaudit_entry *aud);

	// thread-safe base API
	extern struct wcaudit_entry *wcgetaudent(aud_han_t han);
	extern int wcputaudent(aud_han_t han, 
		const struct wcaudit_entry *data);
	extern struct wcaudit_entry *wcgetaudtype(aud_han_t han, 
		int type, const wchar_t *name);
	extern int wcrmaudtype(aud_han_t han, int type, const wchar_t *name);
	
	extern struct wcaudit_entry *wcfgetaudent(FILE * fd);
	extern int wcfputaudent(FILE * fd, const struct wcaudit_entry *data);
#ifdef __cplusplus
}
#endif

#endif	/* _PARSEC_AUD_DB_H_ */
